#!/usr/bin/env bash
#
# A Simple Shell Script to Record 
#
# John Poncini
# Video and Informatics Systems Associate
# MAPS Public Benefit Corporation
# 17 September 2019



while read d; 
    do data+=($d);
done < "/etc/opt/adam/default.info"
declare -p data

DIRNAME="/var/local/media/${data[0]}_${data[2]}_${data[3]}"
FILENAME="${DIRNAME}/${data[4]}"
WEBCAMS=${data[5]}
MICROPHONES=${data[6]}

mkdir ${DIRNAME}

if [ $WEBCAMS == 1  ]; then    
    {
    if [ $MICROPHONES == 0  ]; then
        {
        ffmpeg \
            -f v4l2 -input_format yuyv422 -vcodec h264 -s 1280x720 -r 24 \
            -i /dev/video0 \
            -f alsa -ac 2 -ar 32000 -i hw:1 \                                                             
            -movflags +faststart \
            -map 0 -c:v copy -f segment -segment_time 10 "${FILENAME}_video_%04d.mp4" -vsync 1 \
            -map 1 -c:a aac -f segment -segment_time 10  "${FILENAME}_audio_%04d.m4a" -async 1
        };
    elif [ $MICROPHONES == 1 ]; then
        {
        ffmpeg \
            -f v4l2 -input_format yuyv422 -vcodec h264 -s 1280x720 -r 24 \
            -i /dev/video0 \
            -f alsa -ac 2 -ar 32000 -i hw:1 \
            -f alsa -ac 2 -ar 32000 -i hw:2 \
            -movflags +faststart \
            -map 0 -c:v copy -f segment -segment_time 10 "${FILENAME}_video_%04d.mp4" -vsync 1 \
            -map 1 -c:a aac -f segment -segment_time 10  "${FILENAME}_audio_1_%04d.m4a" -async 1 \
            -map 2 -c:a aac -f segment -segment_time 10  "${FILENAME}_audio_2_%04d.m4a" -async 1
        };
    fi;
    };
elif [ $WEBCAMS == 2 ]; then
    {
    if [ $MICROPHONES == 0  ]; then
        {
        ffmpeg \
            -f v4l2 -input_format yuyv422 -vcodec h264 -s 1280x720 -r 24 \
            -i /dev/video0 \
            -f v4l2 -input_format yuyv422 -vcodec h264 -s 1280x720 -r 24 \
            -i /dev/video2 \
            -f alsa -ac 2 -ar 32000 -i hw:1 \
            -f alsa -ac 2 -ar 32000 -i hw:2 \
            -movflags +faststart \
            -map 0 -c:v copy -f segment -segment_time 10 "${FILENAME}_video_1_%04d.mp4" -vsync 1 \
            -map 1 -c:v copy -f segment -segment_time 10 "${FILENAME}_video_2_%04d.mp4" -vsync 1 \
            -map 2 -c:a aac -f segment -segment_time 10 "${FILENAME}_audio_1_%04d.m4a" -async 1 \
            -map 3 -c:a aac -f segment -segment_time 10 "${FILENAME}_audio_2_%04d.m4a" -async 1
        };
    elif [ $MICROPHONES == 1 ]; then
        {
        ffmpeg \
            -f v4l2 -input_format yuyv422 -vcodec h264 -s 1280x720 -r 24 \
            -i /dev/video0 \
            -f v4l2 -input_format yuyv422 -vcodec h264 -s 1280x720 -r 24 \
            -i /dev/video2 \
            -f alsa -ac 2 -ar 32000 -i hw:1 \
            -f alsa -ac 2 -ar 32000 -i hw:2 \
            -f alsa -ac 2 -ar 32000 -i hw:3 \
            -movflags +faststart \
            -map 0 -c:v copy -f segment -segment_time 10 "${FILENAME}_video_1_%04d.mp4" -vsync 1 \
            -map 1 -c:v copy -f segment -segment_time 10 "${FILENAME}_video_2_%04d.mp4" -vsync 1 \
            -map 2 -c:a aac -f segment -segment_time 10 "${FILENAME}_audio_1_%04d.m4a" -async 1 \
            -map 3 -c:a aac -f segment -segment_time 10 "${FILENAME}_audio_2_%04d.m4a" -async 1 \
            -map 4 -c:a aac -f segment -segment_time 10 "${FILENAME}_audio_3_%04d.m4a" -async 1
        };
    fi;
    };
fi;

